#twisted web2
from knoboo.external.twisted.web2 import http_headers, responsecode
from knoboo.external.twisted.web2 import resource
from knoboo.external.twisted.web2 import http

#json encoding
from knoboo.external import minjson as json
#twisted database acccess
from twisted.enterprise import adbapi

#config
from knoboo import config
kbconfig = config.Config()
cfg = kbconfig.read_config()

DBARGS = {"database":cfg['db_search_path']}
DBSEARCHCONNECTION = adbapi.ConnectionPool(cfg['db_driver'], **DBARGS)
DBmainARGS = {"database":cfg['db_main_path']}
DBmainCON = adbapi.ConnectionPool(cfg['db_driver'], **DBmainARGS)

CTYPE_JSON = {'content-type': http_headers.MimeType('application', 'json', {'charset':'utf-8'})}
CTYPE_UTF8 = {'content-type': http_headers.MimeType('text', 'html', {'charset':'utf-8'})}

SEARCH_IF_ONE_DB = """SELECT notebookId, title, kernel, totalCells, lastModified, locationId 
    FROM notebooks WHERE notebookId IN (SELECT doc_id FROM occurance WHERE word = ? AND avatarId = ?)"""

SEARCH = """SELECT notebookId, title, kernel, totalCells, lastModified, locationId 
    FROM notebooks WHERE notebookId IN (?%s)"""

def _Search(n):
    return SEARCH % (', ?'*(n-1))

def _emany(trans, *args, **kw):
    trans.executemany(*args, **kw)
    return trans.fetchall()


class Search(resource.Resource):
    """search user's notebooks."""

    def __init__(self, avatarId):
        self.avatarId= avatarId

    def render(self, request):
        self.q = request.args.get('q', [''])[0]
        search = "SELECT DISTINCT doc_id FROM occurance WHERE word = ? AND avatarId = ? "
        #search += "ORDER BY occur DESC"
        d = DBSEARCHCONNECTION.runQuery(search, (self.q, self.avatarId))
        d.addCallback(self._searchSuccess)
        #d.addErrback(self._failed)
        return d

    def _searchSuccess(self, result):
        result = tuple(str(i[0]) for i in result)
        if len(result):
            d = DBmainCON.runQuery(_Search(len(result)), (result))
            d.addCallback(self._success)
            #d.addErrback(self._error) user error.trap
            return d
        return self._success([])

    def _success(self, result):
        d = {"results":result, "query":self.q}
        obj = json.write(d, outputEncoding='utf-8')
        return http.Response(responsecode.OK, CTYPE_UTF8, obj)



