##################################################################### 
# Copyright (C) 2007 Alex Clemesha <clemesha@gmail.com>
# 
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
##################################################################### 
from knoboo.external.twisted.web2 import http_headers, responsecode
from knoboo.external.twisted.web2 import resource
from knoboo.external.twisted.web2 import http
from knoboo.external.twisted.web2 import channel
from knoboo.external.twisted.web2 import server
from knoboo.external.twisted.web2 import static 
#standard library
import os
import time
import datetime
import random
import md5
#interface
from zope.interface import Interface, implements

#twisted database acccess
from twisted.enterprise import adbapi
#json encoding
#import simplejson as json
from knoboo.external import minjson as json

#template for the html pages
from knoboo.templates import templates

#sql static queries
import knoboo.sql as sql

#config
from knoboo import config
kbconfig = config.Config()
cfg = kbconfig.read_config()

CTYPE_UTF8 = {'content-type': http_headers.MimeType('text', 'html', {'charset':'utf-8'})}
CTYPE_JSON = {'content-type': http_headers.MimeType('application', 'json', {'charset':'utf-8'})}

class Settings(resource.Resource):
    addSlash = True
 
    def __init__(self, avatarId, dbConnection):
        self.avatarId = avatarId
        self.dbConnection = dbConnection

    def render(self, request):
        back = request.headers.getHeader("Referer")
        html = templates.settings(self.avatarId, back)
        return http.Response(responsecode.OK, CTYPE_UTF8, html)



