import os
import glob
import time

#from knoboo.external 
import jsmin

# External js:
EXTERNAL_BOOKSHELF = ['jquery-ui.min.js', 'jquery.color.min.js', 'jquery.dom.min.js', 'jquery.contextmenu.min.js',
                 'jquery.curvycorners.min.js', 'jqModal.min.js', 'splitter.min.js']

EXTERNAL_NOTEBOOK = ['jquery.ifixpng.min.js', 'jquery.dom.min.js', 'jquery.contextmenu.min.js',
                'Selection.min.js', 'json2.min.js', 'jquery.dimensions.min.js', 'jquery.fieldselection.min.js']

EXTERNAL_LIBS = ['jquery.min.js'] + list(set(EXTERNAL_BOOKSHELF).union(set(EXTERNAL_NOTEBOOK)))


# Knoboo js:
BOOKSHELF_SRC = ['bookshelf.js']

NOTEBOOK_SRC = ['Util.js', 'BrowserDetect.js', 'Notebook.js', 'Indicator.js',
                'Cell.js', 'Async.js', 'Delegator.js', 'DOM.js', 'SaveLoad.js',
                'Spawner.js', 'TreeBranch.js', 'Completer.js']

INTERNAL = [("notebook-compiled-%s.js", NOTEBOOK_SRC), ("bookshelf-compiled-%s.js", BOOKSHELF_SRC)]
EXTERNAL = [("external-compiled-%s.js", EXTERNAL_LIBS)]

INLOC = "../static/js/"
EXLOC = "../static/external/"


def minify_compile(jsfiles, fname):
    jsm = jsmin.JavascriptMinify()
    final = open(INLOC + fname, "a")
    final.write("/* AUTOMATICALLY COMPILED SCRIPT - Copyright (C) 2008 - www.knoboo.com */") 
    for js in jsfiles:
        temp = open(INLOC + js)
        jsm.minify(temp, final)
        temp.close()
    final.close()

def compile(jsfiles, fname):
    final = open(EXLOC + fname, "a")
    for js in jsfiles:
        temp = open(EXLOC + js)
        tempstr = temp.read()
        final.write(tempstr)
        temp.close()
    final.close()


def main():
    oldfiles = glob.glob(INLOC + "*-compiled-*")+ glob.glob(EXLOC + "*-compiled-*")
    for f in oldfiles:
        os.unlink(f)

    for fname, jsfiles in INTERNAL:
        fname = fname % str(int(time.time()))
        minify_compile(jsfiles, fname) 

    for fname, jsfiles in EXTERNAL:
        fname = fname % str(int(time.time()))
        compile(jsfiles, fname) 



if __name__ == "__main__":
    main()


