/*
##################################################################### 
# Copyright (C) 2007 Dorian Raymer <deldotdr@gmail.com>          
# 
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
##################################################################### 


 Notebook.Async - The AJAX functions -- this is where all async 
            communications are defined.

 */

Notebook.Async = function() {
};


// Should Async be a class or not?

Notebook.Async.initialize = function() {
    // eval json written to html body by server
    Notebook.Indicator.loading();
    //var qs = window.location.href.split('?')[1];
    //this.nbid = b.parseQueryString(qs).id;
    //var url = '/operation/nbobject?id=' + this.nbid;
    //var url location.search.split("&")[0].spliti("=")[1];
    var nbid = Notebook.nbid;
    var url = '/operation/nbobject?id=' + nbid;
    //var nbdataobject = a.loadJSONDoc(url);
    var success = function (res) {
        Notebook.Load.takeCellsData(res);
        Notebook.Indicator.loaded();
        }
    //nbdataobject.addCallback(success)
    $.getJSON(url, success);
};

Notebook.Async.signalKernel = function(action) {
    var self = Notebook.Async;
    var nbid = Notebook.nbid;
    var path = '/operation/kernel';
    var data = {'nbid':nbid, 'action':action};
    $.ajax({
            url:path,
            type:'POST',
            data:data,
            dataType:'json',
            success:self.signalSuccess,
            error:self.signalError});


};

Notebook.Async.signalSuccess = function(result) {
};

Notebook.Async.signalError = function(result) {
};

Notebook.Async.evalCell = function(cellid, input) {
    var self = Notebook.Async;
    var nbid = Notebook.nbid;
    var path = '/operation/eval';
    var data = {'nbid':nbid, 'cellid':cellid, 'input':input};
    $.ajax({
            url:path,
            type:'POST',
            data:data,
            dataType:'json',
            success:self.evalSuccess});

    return;
}; 

Notebook.Async.evalSuccess = function(response) {
    var self = Notebook.Async;
    var t = Notebook.TreeBranch;
    var cellid = response.cellid;
    var count = response.count;
    $('#'+cellid)[0].saved = true; //not evaluating
    //This is where numbering of cells could go.
    $('#'+cellid)[0].numberLabel(count);
    var cellstyle = response.cellstyle;
    var content = response.content;
    t.spawnOutputCellNode(cellid, cellstyle, content, count);
    $('#'+cellid)[0].evalResult();
    Notebook.Save._save(self.evalSaveSuccess, self.evalSaveError);
};

Notebook.Async.evalError = function(response) {
};

Notebook.Async.evalSaveSuccess = function(response) {
};

Notebook.Async.evalSaveError = function(response) {
};


Notebook.Async.saveToDatabase = function(orderlist, cellsdata, success, error) {
    var nbid = Notebook.nbid;
    var path = '/operation/save';
    var cells = JSON.stringify(cellsdata);
    var data = {'nbid':nbid, 'orderlist':orderlist, 'cellsdata':cells};
    $.ajax({
            url:path,
            type:'POST',
            data:data,
            dataType:'json',
            success:success,
            error:error});
};

Notebook.Async.deleteCells = function(mainid, ids) {
    var nbid = Notebook.nbid;
    var path = '/operation/delete';
    var cellids = JSON.stringify(ids);
    var data = {'nbid':nbid, 'cellids':cellids};
    /*xxx: need to finish
    var d = a.doXHR(path, {
                    method:'post',
                    headers:{'Content-Type':'application/x-www-form-urlencoded'},
                    sendContent:data});
    var delback = b.partial($(mainid).deleteCallback, mainid)
    d.addCallbacks(delback, $(mainid).deleteErr);
    return d;
    */
};

Notebook.Async.changeNotebookTitle = function(title, success, error) {
    var nbid = Notebook.nbid;
    var path = '/operation/change';
    var data = {'nbid':nbid, 'newtitle':title};
    $.ajax({
            url:path,
            type:'POST',
            data:data,
            dataType:'json',
            success:success,
            error:error});
};



/** completeName - for completing the name of a variable or function */
Notebook.Async.completeName = function(cellid, mode, input, success, error) {
    var nbid = Notebook.nbid;
    //request match from server
    // this ultimatly returns a list of 0 or more match possibilities
    var path = '/operation/completer';
    var data = {'nbid':nbid, 'cellid':cellid, 'mode':mode, 'input':input};
    $.ajax({
            url:path,
            type:'POST',
            data:data,
            dataType:'json',
            success:success,
            error:error});
};

//$(document).ready(Notebook.Async.initialize);
Notebook.__init__.Async = function() {
    Notebook.Async.initialize();
};
