/*

TODO:

    * Loading dialog
    * Undo ability
    * Empty trash / buttons need to reflect current section
    * Don't allow moving of notebooks to current visible section
    * Set sorting direction onload for each notebook column
    * Update bookshelf with new changes (poll for changes) - BUG in 'date' (last modified not working)
    * CSS upload dialog needs improvement.
    * Test 'niceDate' for notebooks older that 1 year.
        

*/

BookShelf = {
	
    _view_map: {'all':0, 'trash':1, 'archive':2, 'folder':3}, //folder needs to be generalized
    _current_view: 'all',
    _update_interval: 5000, /*millisecond interval to check for new changes*/
    _register_update: true, /*bool to be set if user is actively viewing/manipulating the bookshelf*/

	init: function() {
        $('#general-folders').find(".drop").click(BookShelf.generalFolderClick);
        $("#searchbox").submit(BookShelf.searchNotebooks);
        $("#searchbutton").click(BookShelf.searchNotebooks);
        $("#new_folder").click(BookShelf.newFolder);
        $("#new_notebook").click(BookShelf.newNotebook);
        $("#archive_button, #trash_button").click(BookShelf.moveChecked);
        //$(window).blur(BookShelf.periodicUpdate);
        //setInterval(BookShelf.periodicUpdate, BookShelf._update_interval);
        BookShelf.sortCreate();
        //window.location.assign('#all');
        BookShelf.loadUserFolders();
		//BookShelf.loadBookShelf();
        BookShelf.makeListDropable('general-folders');
        BookShelf.ctxMenu();
        $('#_all').click();
	},

    loadBookShelf: function(){
        //form query args
        //var folder = self._view_map[window.location.hash.split('#')[1]] +'&';
        var folder = window.location.hash.split('#')[1] +'&';
        var sort = BookShelf.getSortState();
        var url = 'load?location=' + folder + sort; 
        $.getJSON(url, BookShelf.populateTable);
        //$(window).focus(BookShelf.isUpdateNeeded);
    },

    populateTable: function(data) {
        var trs = [];
        for (var i in data) {
            var nbid = data[i][0];
            var nbtitle = data[i][1];
            var nbkernel = data[i][2];
            var nbtotal = data[i][3];
            var nbtimemod = data[i][4];
            var nblocation = data[i][5];

            var nbpath = '/notebook?' + $.param({id:nbid ,system:nbkernel});

            var td1 = $.TD({width:2, className:nblocation}, $.INPUT({type:'checkbox', className:'deleteradio'}));
            var td2 = $.TD({}, $.A({href:nbpath, className:'nblink', target:'_blank'}, nbtitle));
            var td3 = $.TD({className:'td_kernel'}, nbkernel);
            var td4 = BookShelf.dateTD(nbtimemod);
            var td5 = $.TD({className:'td_totcells'}, nbtotal.toString());
            var tr = $.TR({id:nbid},[td1, td2, td3, td4, td5]);
            trs.push(tr);
        }
        $('tbody.notebooktbody').empty();
        $('tbody.notebooktbody').append(trs);
        BookShelf.redrawTable();
        BookShelf.dragCreate();
        var folder = window.location.hash.split('#')[1];
        //$('#location').text(folder);
    },

    redrawTable: function(){
        $("tbody.notebooktbody tr:even").attr('className', 'even');
        $("tbody.notebooktbody tr:odd").attr('className', 'odd');
    },

    newNotebook: function(){
        var d = new Date();
        var timenow = d.getTime();
        var kernel = "python";
        var href = "new?"+$.param({timenow:timenow, kernel:kernel});
        $("#new_notebook > a").attr("href", href);
    },

    loadUserFolders: function() {
        var url = 'userfolders';
        $.getJSON(url, BookShelf.populateUserFolders);
    },

    populateUserFolders: function(data) {
        var folders = [];
        for (var i in data) {
            var id = '_'+data[i][0];
            var name = data[i][1];

            var folder = $.LI({}, 
                    $.DIV({className:'area-selected'},
                        $.DIV({id:id, className:'drop user-folder'}, name)
                        )
                    );
            folders.push(folder);
        }
        $('div#user-folders > ul').empty();
        $('div#user-folders > ul').append(folders);
        $('#user-folders').find(".drop").click(BookShelf.userFolderClick);
        BookShelf.makeListDropable('user-folders');
    },

    newFolder: function(){
        var data = {'name': 'New Folder'};
        $.ajax({
            type:"POST",
            url:"newfolder", 
            dataType:"json",
            data:data,
            success:BookShelf.newFolderCallback
        });
    },

    newFolderCallback: function(data) {
        var id = '_'+data[0][0];
        var name = data[0][1];
        var folder = $.LI({}, 
                $.DIV({className:'area-selected'},
                    $.DIV({id:id, className:'drop user-folder'}, name)
                    )
                );
        $('div#user-folders > ul').append(folder);
        BookShelf.makeListDropable('user-folders');
        $('#'+id).click(BookShelf.userFolderClick).click();
        $('input.location-name').focus();
    },

    _folderClick: function() {
        //add clicked class to elements with drop class (css)
        $(".area_selected, .drop").css("backgroundColor", "#F5F5F5");
        //move styling to style sheet, set class selected
        $(this).css("backgroundColor", "#DCDCDC");
        $(this).parent(".area_selected").css("backgroundColor", "#DCDCDC");

        var id = $(this).attr("id").split('_')[1];
        var name = $(this).text();
        InfoBar.setLocation(id, name);
        /*
        var userfolderQ = $(this).parents('#user-folders');
        if (userfolderQ.length) {
            var dorename = true;
        } else {
            var dorename = false;
        }
        InfoBar.setLocation(id, name, dorename);
        */
    },

    generalFolderClick: function() {
        $(".area_selected, .drop").css("backgroundColor", "#F5F5F5");
        $(this).css("backgroundColor", "#DCDCDC");
        $(this).parent(".area_selected").css("backgroundColor", "#DCDCDC");
        $('.drop').removeClass('active');
        $(this).addClass('active');
        var id = $(this).attr("id").split('_')[1];
        var name = $(this).text();
        $("div.infobar").hide();
        InfoBar.setLocation(id, name);
        BookShelf.loadBookShelf();
    },

    userFolderClick: function() {
        $(".area_selected, .drop").css("backgroundColor", "#F5F5F5");
        $(this).css("backgroundColor", "#DCDCDC");
        $(this).parent(".area_selected").css("backgroundColor", "#DCDCDC");
        $('.drop').removeClass('active');
        $(this).addClass('active');
        var id = $(this).attr("id").split('_')[1];
        var name = $(this).text();
        InfoBar.setRename(id, name);
        $("div.infobar").show();
        BookShelf.loadBookShelf();

    },

    moveData: function(nbid, destination) {
        var data = {'dest':destination, 'nbid':nbid};
        $.map(nbid, function(n,i) {
            //$('#'+nbid).remove();
            $('#'+n).remove();
            });
        BookShelf.redrawTable();
        $.ajax({
            type:"POST",
            url:"move", 
            dataType:"json",
            data:data,
            success:BookShelf.moveDataCallback
        });
    },

    moveDataCallback: function(res) {
    },

	moveChecked: function(){
        var destination = $(this).attr("id").split("_")[0];
        var checked = $("input:checked").parents('tr');
        var checkedid = $.map(checked, function(n, i) {
            return $(n).attr('id');
            });
        if (checkedid.length == 0) {
            StatusDialog.showMessage("No notebooks are selected.");
            return;
        }
        BookShelf.moveData(checkedid, destination);
    },


    movectxMenu: function(e, dest){
        //if (self._current_view == dest) return;
        BookShelf.moveData(BookShelf._contextSelected, BookShelf._view_map[dest]);
        $("#drop_"+dest).animate({backgroundColor:"#FF0"},200).animate({backgroundColor:"#EEF2F5"},200);
        BookShelf._contextSelected = '';
    },

    ctxMenu: function(){
        var ctx_opts = {
            bindings: {
                "ctx_all": function(t) {
                    return BookShelf.movectxMenu(t, "all");
                },
                "ctx_folder": function(t) {
                    return BookShelf.movectxMenu(t, "folder");
                },
                "ctx_archive": function(t) {
                    return BookShelf.movectxMenu(t, "archive");
                },
                "ctx_trash": function(t) {
                    return BookShelf.movectxMenu(t, "trash");
                }
            },
            onContextMenu: function(e) {
                var what = $(e.originalTarget).parents('tr');
                if (what) {
                    BookShelf._contextSelected = $(what).attr('id');
                    return true;
                }
                return false;
            },
            onShowMenu: function(e, menu) {
                menu.what = e.what;
                return menu;
            }
        };
        $("tbody").contextMenu("ctxmenu", ctx_opts);
    },


    /* === Search of notebooks functionality === 
     *
     *     The submit event of the search form and 
     *     the 'click' event of the Search button
     *     by the 'searchNotebooks' function.
     *
     *     On success of the search query, the notebooks
     *     table is redrawn with the data of all matched notebooks.
     */
    searchNotebooks: function() {
        //$("#tablestate_empty, #tablestate_search").remove(); //remove any messages

        var q = $("#searchquery").attr("value");
        if (q) {
            $.ajax({
                type: "GET",
                url: "search", 
                data: {"q": q}, 
                dataType: "json",
                success: BookShelf.searchResults
            });
        }
        return false;
    },

    /* 'searchResults' first clears any last search results 
     *  from the _history["search"] array.
     *
     *  The we loop over all existing notebooks and take
     *  all the notebooks (in the _history["all"] array)
     *  and redraw a new notebook table with the matches
     */
    searchResults: function(data) {
        var msgs = [$.SPAN({},"Search results for:"), $.SPAN({className:'squery'}, data.query)];
        var msg = $.P({id:"tablestate_search"}, msgs);
        //$("table").before(msg);
        BookShelf.populateTable(data.results);
    },
    /* === End Search notebooks functionality === */


    dragCreate: function(){
        var colorDrag = function() {
            var uid = new Date().getTime();
            return $(this).clone().attr({id:uid}).css({
                    "backgroundColor":"#9BC2E9", 
                    "border-style": "dashed",
                    "border-width": "2px"});
        }
        var startLog = function() {
            return;
        }
        var stopDrag = function() {};

        $("tbody tr").draggable({
            opacity:0.8, 
            revert:true, 
            helper:colorDrag, 
            start:startLog,
            stop:stopDrag
        });
	},

    makeListDropable: function(listid) {
        var getDropped = function(ev, ui){
            $(ui.droppable.element).animate({backgroundColor:"#FF0"},200)
            .animate({backgroundColor:$(this).css("backgroundColor")},200);

            var drop_id = $(ui.droppable.element).attr("id");
            var drag_id = $(ui.draggable.element).attr("id");
                var destination = drop_id.split('_')[1]; 
                //Destination id should be set in template?
                BookShelf.moveData(drag_id, destination);
            };
        var overfun = function(ev, ui){$.extend(ui.draggable.options, {revert:false})}
        var outfun = function(ev, ui){$.extend(ui.draggable.options, {revert:true})}

        $('#'+listid).find(".drop").droppable({
            accept:"tr",
            tolerance: "pointer",
            hoverClass: "drop_ok",
            //over: overfun,
            //out: outfun,
            drop: getDropped
        });
    },

	XdropCreate: function(){
        var getDropped = function(ev, ui){
            $(ui.droppable.element).animate({backgroundColor:"#FF0"},200).animate({backgroundColor:$(this).css("backgroundColor")},200);
            var drop_id = $(ui.droppable.element).attr("id");
            var drag_id = $(ui.draggable.element).attr("id");
                //var destination = BookShelf._view_map[drop_id.split("_")[1]];
                var destination = drop_id.split('_')[1]; 
                //Destination id should be set in template?
                BookShelf.moveData(drag_id, destination);
            };
        var overfun = function(ev, ui){$.extend(ui.draggable.options, {revert:false})}
        var outfun = function(ev, ui){$.extend(ui.draggable.options, {revert:true})}

        $(".drop").droppable({
            accept:"tr",
            tolerance: "pointer",
            hoverClass: "drop_ok",
            //over: overfun,
            //out: outfun,
            drop: getDropped
        });
    },

    sortCreate: function() {
        $('thead td.sortable').click(BookShelf.sortClick);
        $('td#column_date').addClass('active desc');
    },

    sortClick: function(e) {
        if ($(this).hasClass('active')) {
            $(this).hasClass('asc') ? $(this).removeClass('asc').addClass('desc') :
                $(this).removeClass('desc').addClass('asc');
        } else {
            $('thead td').removeClass('active asc desc');
            $(this).addClass('active desc');
        }
        BookShelf.loadBookShelf();
    },

    getSortState: function() {
        var col = $('thead td.active');
        var order = $(col).attr('id').split('_')[1];
        var sort = $(col).hasClass('asc') ? 'asc' : 'desc';
        return $.param({'order':order, 'sort':sort});
    },

    niceDate: function(dat){
        var offset = (new Date()).getTimezoneOffset() * 60 * 1000;
        var local = (dat.getTime() - offset); 
        var diff = (((new Date()).getTime() - local) / 1000);
		var day_diff = Math.floor(diff / 172800);

        if ( isNaN(day_diff) || day_diff < 0 || day_diff >= 31 )
            return;
        return day_diff == 0 && (
            diff < 60 && "just now" ||
            diff < 120 && "1 minute ago" ||
            diff < 3600 && Math.floor( diff / 60 ) + " minutes ago" ||
            diff < 7200 && "1 hour ago" ||
            diff < 172800 && Math.floor( diff / 3600 ) + " hours ago") ||
            day_diff == 1 && "Yesterday" ||
            day_diff < 7 && day_diff + " days ago" ||
            day_diff < 31 && Math.ceil( day_diff / 7 ) + " weeks ago";
    },

    dateTD: function(data){
        /* var DAYS = ['Sun', 'Mon','Tues','Wed','Thurs','Fri','Sat']; 
        var MONTHS = ['Jan','Feb','Mar','Apr','May','June','July','Aug','Sept','Oct','Nov','Dec'];
        var d = new Date(parseInt(data));
        var day = DAYS[d.getDay()];
        var dates = d.getDate();
        var month = MONTHS[d.getMonth()];
        var minutes = d.getMinutes();
        if (parseInt(minutes/10) == 0) minutes = "0"+minutes;
        var hours = d.getHours();
        if (hours/12 > 1) {
            var td = hours-12;
            var t = td+":"+minutes+"pm";
        } else {
            if (hours == 0) hours = 12;
            var t = hours+":"+minutes+"am";
        }
        var nicedate = day+", "+month+" "+dates+", "+t; */
        data = data.replace(/-/g, "/") + ' GMT'
        var dat = new Date(data);
        var nicedate = BookShelf.niceDate(dat);
		var epoch = Math.floor(dat.getTime());
        return $.TD({id:epoch, className:'td_datemod'}, nicedate); //+" - "+d.getFullYear());
    }

};



InfoBar = {
    setLocation: function(loc, name) {
        window.location.assign('#'+loc);
    },

    setRename: function(loc, name) {
        InfoBar.setLocation(loc, name);
        InfoBar.reset();
        $('input.location-name').val(name);
        InfoBar.activateRename();

    },

    reset: function() {
        $('#rename-folder').unbind();
        $('input.location-name').removeClass('active');
        $('input.location-name')[0].readOnly = true;
    },

    activateRename: function() {
        //$('input.location-name').hover(self.overCallback, self.outCallback);
        $('input.location-name').addClass('active');
        $('#rename-folder').submit(InfoBar.rename);
        $('input.location-name')[0].readOnly = false;
    },

    

    overCallback: function(e) {

    },

    overCallback: function(e) {

    },

    click: function(e) {

    },

    rename: function() {
        var id = window.location.hash.split('#')[1];
        var newname = $('input.location-name').val();
        var data = {'name': newname, 'id':id};
        $(this).children('input').blur();
        $.ajax({
            type:"POST",
            url:"renamefolder", 
            dataType:"json",
            data:data,
            success:InfoBar.renameFolderCallback
        });
        return false;
    },

    renameFolderCallback: function(data) {
        var id = '_'+data[0][0];
        var name = data[0][1];
        $('#'+id).text(name); 
    }
};

/* Styling and visual feedback for the BookShelf */
BookShelfStyling = {
    init: function(){
        var split_opts = {type: 'v', initA: true, splitbarClass: 'panehandle'};
        $('#splitpane').splitter(split_opts);
    	$("#attach_overlay").jqm();
    	$(".button").corner({autoPad:true, antiAlias:true, tl:{radius:4}, tr:{radius:4}, bl:{radius:4}, br:{radius:4}});
    	$("#control").corner({autoPad:true, antiAlias:true, tl:{radius:4}, tr:{radius:4}, bl:{radius:0}, br:{radius:0}});
        $("#status_close, .button, .drop").hover(function(){$(this).addClass('pointer');}, function(){$(this).removeClass('pointer');});
        $(window).bind('resize', function() {
                $('#splitpane').trigger('resize');
                }).trigger('resize');
    }
};

StatusDialog = {

    showMessage: function(msg){
        $("#status_message").text(msg);
        $("#status").show().animate({"top":"-16"}, 400);
        setTimeout("StatusDialog.closeDialog()", 3000);
    },

    closeDialog: function(){
        $("#status").animate({"top":"16"}, 500);
    }
};


AttachData = {
    init: function(){
        $("#uploadform").submit(AttachData.handleUpload); 
        $("#remote_attach").submit(AttachData.handleRemoteFile); 
    },

    handleRemoteFile: function(){
        var url = $(this).children("input:first").val();
        $.ajax({
            type: "GET",
            url: "attachremote", 
            data: {"url": url}, 
            dataType: "json",
            success: function(data){return;}//console.log(data)}
        });
        return false;
    },
    
    handleUpload: function(){
        var e = $(this);
        idoc = $("iframe")[0];
        //console.log(e, idoc);
        btn = $(idoc.contentWindow.document.getElementById("upload_btn"));
        form = idoc.contentWindow.document.getElementById("uploadform");
        $(btn).click(function(){ form.submit(); });
    },
    
    dFrame: function(){
        idoc = $("iframe")[0];
        btn = $(idoc.contentWindow.document.getElementById("upload_btn"));
        form = idoc.contentWindow.document.getElementById("uploadform");
        $(btn).click(function(){ form.submit(); });
    }
};
    

PeriodicUpdater = {
    isUpdateNeeded: function(){
        if (BookShelf._register_update) {
            setTimeout(BookShelf.periodicUpdate, BookShelf._update_interval);
            BookShelf._register_update = false;
        }
    },

    periodicUpdate: function(){
        $("tbody").empty();
        BookShelf._history = {'all':[], 'trash':[], 'archive':[], 'folder':[], 'search':[]};
        $.getJSON("load", BookShelf.createTable);
        BookShelf._register_update = true;
    }


};


$(document).ready(function(){
    BookShelf.init();
    BookShelfStyling.init();
    AttachData.init();    
});




